Skip to content
Ona Docs

CreateProject

POST/gitpod.v1.ProjectService/CreateProject

Creates a new project with specified configuration.

Use this method to:

  • Set up development projects
  • Configure project environments
  • Define project settings
  • Initialize project content

Examples

  • Create basic project:

    Creates a project with minimal configuration.

    name: "Web Application"
    initializer:
      specs:
        - git:
            remoteUri: "https://github.com/org/repo"
  • Create project with devcontainer:

    Creates a project with custom development container.

    name: "Backend Service"
    initializer:
      specs:
        - git:
            remoteUri: "https://github.com/org/backend"
    devcontainerFilePath: ".devcontainer/devcontainer.json"
    automationsFilePath: ".gitpod/automations.yaml"
Body ParametersJSONExpand Collapse
initializer: EnvironmentInitializer { specs }

initializer is the content initializer

specs: optional array of object { contextUrl, git }
contextUrl: optional object { url }
url: optional string

url is the URL from which the environment is created

formaturi
git: optional object { checkoutLocation, cloneTarget, remoteUri, 2 more }
checkoutLocation: optional string

a path relative to the environment root in which the code will be checked out to

cloneTarget: optional string

the value for the clone target mode - use depends on the target mode

remoteUri: optional string

remote_uri is the Git remote origin

targetMode: optional "CLONE_TARGET_MODE_UNSPECIFIED" or "CLONE_TARGET_MODE_REMOTE_HEAD" or "CLONE_TARGET_MODE_REMOTE_COMMIT" or 3 more

the target mode determines what gets checked out

One of the following:
"CLONE_TARGET_MODE_UNSPECIFIED"
"CLONE_TARGET_MODE_REMOTE_HEAD"
"CLONE_TARGET_MODE_REMOTE_COMMIT"
"CLONE_TARGET_MODE_REMOTE_BRANCH"
"CLONE_TARGET_MODE_LOCAL_BRANCH"
"CLONE_TARGET_MODE_REMOTE_TAG"
upstreamRemoteUri: optional string

upstream_Remote_uri is the fork upstream of a repository

automationsFilePath: optional string

automations_file_path is the path to the automations file relative to the repo root path must not be absolute (start with a /):

this.matches('^$|^[^/].*')
devcontainerFilePath: optional string

devcontainer_file_path is the path to the devcontainer file relative to the repo root path must not be absolute (start with a /):

this.matches('^$|^[^/].*')
name: optional string
maxLength80
minLength1
prebuildConfiguration: optional ProjectPrebuildConfiguration { enabled, enableJetbrainsWarmup, environmentClassIds, 3 more }

prebuild_configuration defines how prebuilds are created for this project. If not set, prebuilds are disabled for the project.

enabled: optional boolean

enabled controls whether prebuilds are created for this project. When disabled, no automatic prebuilds will be triggered.

enableJetbrainsWarmup: optional boolean

enable_jetbrains_warmup controls whether JetBrains IDE warmup runs during prebuilds.

environmentClassIds: optional array of string

environment_class_ids specifies which environment classes should have prebuilds created. If empty, no prebuilds are created.

executor: optional Subject { id, principal }

executor specifies who runs prebuilds for this project. The executor’s SCM credentials are used to clone the repository. If not set, defaults to the project creator.

id: optional string

id is the UUID of the subject

formatuuid
principal: optional Principal

Principal is the principal of the subject

One of the following:
"PRINCIPAL_UNSPECIFIED"
"PRINCIPAL_ACCOUNT"
"PRINCIPAL_USER"
"PRINCIPAL_RUNNER"
"PRINCIPAL_ENVIRONMENT"
"PRINCIPAL_SERVICE_ACCOUNT"
"PRINCIPAL_RUNNER_MANAGER"
timeout: optional string

timeout is the maximum duration allowed for a prebuild to complete. If not specified, defaults to 1 hour. Must be between 5 minutes and 2 hours.

formatregex
trigger: optional object { dailySchedule }

trigger defines when prebuilds should be created.

dailySchedule: object { hourUtc }

daily_schedule triggers a prebuild once per day at the specified hour (UTC). The actual start time may vary slightly to distribute system load.

hourUtc: optional number

hour_utc is the hour of day (0-23) in UTC when the prebuild should start. The actual start time may be adjusted by a few minutes to balance system load.

formatint32
maximum23
technicalDescription: optional string

technical_description is a detailed technical description of the project This field is not returned by default in GetProject or ListProjects responses 8KB max

maxLength8192
ReturnsExpand Collapse
project: optional Project { environmentClass, id, automationsFilePath, 9 more }
DeprecatedenvironmentClass: ProjectEnvironmentClass { environmentClassId, localRunner, order }

Use environment_classes instead.

environmentClassId: optional string

Use a fixed environment class on a given Runner. This cannot be a local runner’s environment class.

formatuuid
localRunner: optional boolean

Use a local runner for the user

order: optional number

order is the priority of this entry

formatint32
id: optional string

id is the unique identifier for the project

formatuuid
automationsFilePath: optional string

automations_file_path is the path to the automations file relative to the repo root

desiredPhase: optional ProjectPhase

desired_phase is the desired phase of the project When set to DELETED, the project is pending deletion

One of the following:
"PROJECT_PHASE_UNSPECIFIED"
"PROJECT_PHASE_ACTIVE"
"PROJECT_PHASE_DELETED"
devcontainerFilePath: optional string

devcontainer_file_path is the path to the devcontainer file relative to the repo root

environmentClasses: optional array of ProjectEnvironmentClass { environmentClassId, localRunner, order }

environment_classes is the list of environment classes for the project

environmentClassId: optional string

Use a fixed environment class on a given Runner. This cannot be a local runner’s environment class.

formatuuid
localRunner: optional boolean

Use a local runner for the user

order: optional number

order is the priority of this entry

formatint32
initializer: optional EnvironmentInitializer { specs }

initializer is the content initializer

specs: optional array of object { contextUrl, git }
contextUrl: optional object { url }
url: optional string

url is the URL from which the environment is created

formaturi
git: optional object { checkoutLocation, cloneTarget, remoteUri, 2 more }
checkoutLocation: optional string

a path relative to the environment root in which the code will be checked out to

cloneTarget: optional string

the value for the clone target mode - use depends on the target mode

remoteUri: optional string

remote_uri is the Git remote origin

targetMode: optional "CLONE_TARGET_MODE_UNSPECIFIED" or "CLONE_TARGET_MODE_REMOTE_HEAD" or "CLONE_TARGET_MODE_REMOTE_COMMIT" or 3 more

the target mode determines what gets checked out

One of the following:
"CLONE_TARGET_MODE_UNSPECIFIED"
"CLONE_TARGET_MODE_REMOTE_HEAD"
"CLONE_TARGET_MODE_REMOTE_COMMIT"
"CLONE_TARGET_MODE_REMOTE_BRANCH"
"CLONE_TARGET_MODE_LOCAL_BRANCH"
"CLONE_TARGET_MODE_REMOTE_TAG"
upstreamRemoteUri: optional string

upstream_Remote_uri is the fork upstream of a repository

metadata: optional ProjectMetadata { createdAt, creator, name, 2 more }
createdAt: optional string

A Timestamp represents a point in time independent of any time zone or local calendar, encoded as a count of seconds and fractions of seconds at nanosecond resolution. The count is relative to an epoch at UTC midnight on January 1, 1970, in the proleptic Gregorian calendar which extends the Gregorian calendar backwards to year one.

All minutes are 60 seconds long. Leap seconds are “smeared” so that no leap second table is needed for interpretation, using a 24-hour linear smear.

The range is from 0001-01-01T00:00:00Z to 9999-12-31T23:59:59.999999999Z. By restricting to that range, we ensure that we can convert to and from RFC 3339 date strings.

Examples

Example 1: Compute Timestamp from POSIX time().

 Timestamp timestamp;
 timestamp.set_seconds(time(NULL));
 timestamp.set_nanos(0);

Example 2: Compute Timestamp from POSIX gettimeofday().

 struct timeval tv;
 gettimeofday(&tv, NULL);

 Timestamp timestamp;
 timestamp.set_seconds(tv.tv_sec);
 timestamp.set_nanos(tv.tv_usec * 1000);

Example 3: Compute Timestamp from Win32 GetSystemTimeAsFileTime().

 FILETIME ft;
 GetSystemTimeAsFileTime(&ft);
 UINT64 ticks = (((UINT64)ft.dwHighDateTime) << 32) | ft.dwLowDateTime;

 // A Windows tick is 100 nanoseconds. Windows epoch 1601-01-01T00:00:00Z
 // is 11644473600 seconds before Unix epoch 1970-01-01T00:00:00Z.
 Timestamp timestamp;
 timestamp.set_seconds((INT64) ((ticks / 10000000) - 11644473600LL));
 timestamp.set_nanos((INT32) ((ticks % 10000000) * 100));

Example 4: Compute Timestamp from Java System.currentTimeMillis().

 long millis = System.currentTimeMillis();

 Timestamp timestamp = Timestamp.newBuilder().setSeconds(millis / 1000)
     .setNanos((int) ((millis % 1000) * 1000000)).build();

Example 5: Compute Timestamp from Java Instant.now().

 Instant now = Instant.now();

 Timestamp timestamp =
     Timestamp.newBuilder().setSeconds(now.getEpochSecond())
         .setNanos(now.getNano()).build();

Example 6: Compute Timestamp from current time in Python.

 timestamp = Timestamp()
 timestamp.GetCurrentTime()

JSON Mapping

In JSON format, the Timestamp type is encoded as a string in the RFC 3339 format. That is, the format is “{year}-{month}-{day}T{hour}:{min}:{sec}[.{frac_sec}]Z” where {year} is always expressed using four digits while {month}, {day}, {hour}, {min}, and {sec} are zero-padded to two digits each. The fractional seconds, which can go up to 9 digits (i.e. up to 1 nanosecond resolution), are optional. The “Z” suffix indicates the timezone (“UTC”); the timezone is required. A proto3 JSON serializer should always use UTC (as indicated by “Z”) when printing the Timestamp type and a proto3 JSON parser should be able to accept both UTC and other timezones (as indicated by an offset).

For example, “2017-01-15T01:30:15.01Z” encodes 15.01 seconds past 01:30 UTC on January 15, 2017.

In JavaScript, one can convert a Date object to this format using the standard toISOString() method. In Python, a standard datetime.datetime object can be converted to this format using strftime with the time format spec ‘%Y-%m-%dT%H:%M:%S.%fZ’. Likewise, in Java, one can use the Joda Time’s ISODateTimeFormat.dateTime() to obtain a formatter capable of generating timestamps in this format.

formatdate-time
creator: optional Subject { id, principal }

creator is the identity of the project creator

id: optional string

id is the UUID of the subject

formatuuid
principal: optional Principal

Principal is the principal of the subject

One of the following:
"PRINCIPAL_UNSPECIFIED"
"PRINCIPAL_ACCOUNT"
"PRINCIPAL_USER"
"PRINCIPAL_RUNNER"
"PRINCIPAL_ENVIRONMENT"
"PRINCIPAL_SERVICE_ACCOUNT"
"PRINCIPAL_RUNNER_MANAGER"
name: optional string

name is the human readable name of the project

maxLength80
minLength1
organizationId: optional string

organization_id is the ID of the organization that contains the environment

formatuuid
updatedAt: optional string

A Timestamp represents a point in time independent of any time zone or local calendar, encoded as a count of seconds and fractions of seconds at nanosecond resolution. The count is relative to an epoch at UTC midnight on January 1, 1970, in the proleptic Gregorian calendar which extends the Gregorian calendar backwards to year one.

All minutes are 60 seconds long. Leap seconds are “smeared” so that no leap second table is needed for interpretation, using a 24-hour linear smear.

The range is from 0001-01-01T00:00:00Z to 9999-12-31T23:59:59.999999999Z. By restricting to that range, we ensure that we can convert to and from RFC 3339 date strings.

Examples

Example 1: Compute Timestamp from POSIX time().

 Timestamp timestamp;
 timestamp.set_seconds(time(NULL));
 timestamp.set_nanos(0);

Example 2: Compute Timestamp from POSIX gettimeofday().

 struct timeval tv;
 gettimeofday(&tv, NULL);

 Timestamp timestamp;
 timestamp.set_seconds(tv.tv_sec);
 timestamp.set_nanos(tv.tv_usec * 1000);

Example 3: Compute Timestamp from Win32 GetSystemTimeAsFileTime().

 FILETIME ft;
 GetSystemTimeAsFileTime(&ft);
 UINT64 ticks = (((UINT64)ft.dwHighDateTime) << 32) | ft.dwLowDateTime;

 // A Windows tick is 100 nanoseconds. Windows epoch 1601-01-01T00:00:00Z
 // is 11644473600 seconds before Unix epoch 1970-01-01T00:00:00Z.
 Timestamp timestamp;
 timestamp.set_seconds((INT64) ((ticks / 10000000) - 11644473600LL));
 timestamp.set_nanos((INT32) ((ticks % 10000000) * 100));

Example 4: Compute Timestamp from Java System.currentTimeMillis().

 long millis = System.currentTimeMillis();

 Timestamp timestamp = Timestamp.newBuilder().setSeconds(millis / 1000)
     .setNanos((int) ((millis % 1000) * 1000000)).build();

Example 5: Compute Timestamp from Java Instant.now().

 Instant now = Instant.now();

 Timestamp timestamp =
     Timestamp.newBuilder().setSeconds(now.getEpochSecond())
         .setNanos(now.getNano()).build();

Example 6: Compute Timestamp from current time in Python.

 timestamp = Timestamp()
 timestamp.GetCurrentTime()

JSON Mapping

In JSON format, the Timestamp type is encoded as a string in the RFC 3339 format. That is, the format is “{year}-{month}-{day}T{hour}:{min}:{sec}[.{frac_sec}]Z” where {year} is always expressed using four digits while {month}, {day}, {hour}, {min}, and {sec} are zero-padded to two digits each. The fractional seconds, which can go up to 9 digits (i.e. up to 1 nanosecond resolution), are optional. The “Z” suffix indicates the timezone (“UTC”); the timezone is required. A proto3 JSON serializer should always use UTC (as indicated by “Z”) when printing the Timestamp type and a proto3 JSON parser should be able to accept both UTC and other timezones (as indicated by an offset).

For example, “2017-01-15T01:30:15.01Z” encodes 15.01 seconds past 01:30 UTC on January 15, 2017.

In JavaScript, one can convert a Date object to this format using the standard toISOString() method. In Python, a standard datetime.datetime object can be converted to this format using strftime with the time format spec ‘%Y-%m-%dT%H:%M:%S.%fZ’. Likewise, in Java, one can use the Joda Time’s ISODateTimeFormat.dateTime() to obtain a formatter capable of generating timestamps in this format.

formatdate-time
prebuildConfiguration: optional ProjectPrebuildConfiguration { enabled, enableJetbrainsWarmup, environmentClassIds, 3 more }

prebuild_configuration defines how prebuilds are created for this project.

enabled: optional boolean

enabled controls whether prebuilds are created for this project. When disabled, no automatic prebuilds will be triggered.

enableJetbrainsWarmup: optional boolean

enable_jetbrains_warmup controls whether JetBrains IDE warmup runs during prebuilds.

environmentClassIds: optional array of string

environment_class_ids specifies which environment classes should have prebuilds created. If empty, no prebuilds are created.

executor: optional Subject { id, principal }

executor specifies who runs prebuilds for this project. The executor’s SCM credentials are used to clone the repository. If not set, defaults to the project creator.

id: optional string

id is the UUID of the subject

formatuuid
principal: optional Principal

Principal is the principal of the subject

One of the following:
"PRINCIPAL_UNSPECIFIED"
"PRINCIPAL_ACCOUNT"
"PRINCIPAL_USER"
"PRINCIPAL_RUNNER"
"PRINCIPAL_ENVIRONMENT"
"PRINCIPAL_SERVICE_ACCOUNT"
"PRINCIPAL_RUNNER_MANAGER"
timeout: optional string

timeout is the maximum duration allowed for a prebuild to complete. If not specified, defaults to 1 hour. Must be between 5 minutes and 2 hours.

formatregex
trigger: optional object { dailySchedule }

trigger defines when prebuilds should be created.

dailySchedule: object { hourUtc }

daily_schedule triggers a prebuild once per day at the specified hour (UTC). The actual start time may vary slightly to distribute system load.

hourUtc: optional number

hour_utc is the hour of day (0-23) in UTC when the prebuild should start. The actual start time may be adjusted by a few minutes to balance system load.

formatint32
maximum23
recommendedEditors: optional RecommendedEditors { editors }

recommended_editors specifies the editors recommended for this project.

technicalDescription: optional string

technical_description is a detailed technical description of the project This field is not returned by default in GetProject or ListProjects responses

usedBy: optional object { subjects, totalSubjects }
subjects: optional array of Subject { id, principal }

Subjects are the 10 most recent subjects who have used the project to create an environment

id: optional string

id is the UUID of the subject

formatuuid
principal: optional Principal

Principal is the principal of the subject

One of the following:
"PRINCIPAL_UNSPECIFIED"
"PRINCIPAL_ACCOUNT"
"PRINCIPAL_USER"
"PRINCIPAL_RUNNER"
"PRINCIPAL_ENVIRONMENT"
"PRINCIPAL_SERVICE_ACCOUNT"
"PRINCIPAL_RUNNER_MANAGER"
totalSubjects: optional number

Total number of unique subjects who have used the project

formatint32

CreateProject

curl https://app.gitpod.io/api/gitpod.v1.ProjectService/CreateProject \
    -H 'Content-Type: application/json' \
    -H "Authorization: Bearer $GITPOD_API_KEY" \
    -d '{
          "initializer": {
            "specs": [
              {
                "git": {
                  "remoteUri": "https://github.com/org/repo"
                }
              }
            ]
          }
        }'
{
  "project": {
    "environmentClass": {
      "environmentClassId": "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e",
      "localRunner": true,
      "order": 0
    },
    "id": "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e",
    "automationsFilePath": "automationsFilePath",
    "desiredPhase": "PROJECT_PHASE_UNSPECIFIED",
    "devcontainerFilePath": "devcontainerFilePath",
    "environmentClasses": [
      {
        "environmentClassId": "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e",
        "localRunner": true,
        "order": 0
      }
    ],
    "initializer": {
      "specs": [
        {
          "contextUrl": {
            "url": "https://example.com"
          },
          "git": {
            "checkoutLocation": "checkoutLocation",
            "cloneTarget": "cloneTarget",
            "remoteUri": "remoteUri",
            "targetMode": "CLONE_TARGET_MODE_UNSPECIFIED",
            "upstreamRemoteUri": "upstreamRemoteUri"
          }
        }
      ]
    },
    "metadata": {
      "createdAt": "2019-12-27T18:11:19.117Z",
      "creator": {
        "id": "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e",
        "principal": "PRINCIPAL_UNSPECIFIED"
      },
      "name": "x",
      "organizationId": "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e",
      "updatedAt": "2019-12-27T18:11:19.117Z"
    },
    "prebuildConfiguration": {
      "enabled": true,
      "enableJetbrainsWarmup": true,
      "environmentClassIds": [
        "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e"
      ],
      "executor": {
        "id": "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e",
        "principal": "PRINCIPAL_UNSPECIFIED"
      },
      "timeout": "+9125115.360s",
      "trigger": {
        "dailySchedule": {
          "hourUtc": 23
        }
      }
    },
    "recommendedEditors": {
      "editors": {
        "foo": {
          "versions": [
            "string"
          ]
        }
      }
    },
    "technicalDescription": "technicalDescription",
    "usedBy": {
      "subjects": [
        {
          "id": "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e",
          "principal": "PRINCIPAL_UNSPECIFIED"
        }
      ],
      "totalSubjects": 0
    }
  }
}
Returns Examples
{
  "project": {
    "environmentClass": {
      "environmentClassId": "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e",
      "localRunner": true,
      "order": 0
    },
    "id": "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e",
    "automationsFilePath": "automationsFilePath",
    "desiredPhase": "PROJECT_PHASE_UNSPECIFIED",
    "devcontainerFilePath": "devcontainerFilePath",
    "environmentClasses": [
      {
        "environmentClassId": "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e",
        "localRunner": true,
        "order": 0
      }
    ],
    "initializer": {
      "specs": [
        {
          "contextUrl": {
            "url": "https://example.com"
          },
          "git": {
            "checkoutLocation": "checkoutLocation",
            "cloneTarget": "cloneTarget",
            "remoteUri": "remoteUri",
            "targetMode": "CLONE_TARGET_MODE_UNSPECIFIED",
            "upstreamRemoteUri": "upstreamRemoteUri"
          }
        }
      ]
    },
    "metadata": {
      "createdAt": "2019-12-27T18:11:19.117Z",
      "creator": {
        "id": "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e",
        "principal": "PRINCIPAL_UNSPECIFIED"
      },
      "name": "x",
      "organizationId": "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e",
      "updatedAt": "2019-12-27T18:11:19.117Z"
    },
    "prebuildConfiguration": {
      "enabled": true,
      "enableJetbrainsWarmup": true,
      "environmentClassIds": [
        "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e"
      ],
      "executor": {
        "id": "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e",
        "principal": "PRINCIPAL_UNSPECIFIED"
      },
      "timeout": "+9125115.360s",
      "trigger": {
        "dailySchedule": {
          "hourUtc": 23
        }
      }
    },
    "recommendedEditors": {
      "editors": {
        "foo": {
          "versions": [
            "string"
          ]
        }
      }
    },
    "technicalDescription": "technicalDescription",
    "usedBy": {
      "subjects": [
        {
          "id": "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e",
          "principal": "PRINCIPAL_UNSPECIFIED"
        }
      ],
      "totalSubjects": 0
    }
  }
}